<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2008 Tim Lochmueller
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class tx_flrealurlimage_fehook {    

	/*
	 * Hook method for realurl image decode
	 *
	 * @param	
	 * @param	 	 
	 * @return 	nothing
	 */
	function checkImageDecode (&$params,&$ref) {
    	$this->pagePathtoID(); 	  
	}
    
	/*
	* Outputting the image that fits to the realurl request
	* Notice: normally the image should be in the static file cache
	* ... so this is an emergency action only when no image is in static file cache
	* -> to do
	* 1) outputting image
	* 2) recreate the static file cache
	* 3) updating the DB-Entry
	*		
	* @param		nothing
	* @return		nothing
	*/
	function pagePathtoID() {
	    // init
	    $this->fl_conf = $GLOBALS['fl_realurl_image'];
	    // Path of the requested image
		$path = $this->fl_conf['virtualPathRemove'].str_replace(t3lib_div::getIndpEnv('TYPO3_SITE_URL'),"",t3lib_div::getIndpEnv('TYPO3_REQUEST_URL'));
#debug($path);
		// look up in DB-table if there is a image stored for this realurl
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('image_path,tstamp,realurl_path,page_id','tx_flrealurlimage_cache','realurl_path=\''.$path.'\'', '', '', 1);
		if($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0){
			// get the information to the requested image
			$data = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
			// update DB to idicate that image was requested
			if (!strstr($data['page_id'],'?')) {
		    	$page_id = $data['page_id'].',?';
			}
			else {
			    $page_id = $data['page_id'];
			}
			$insertArray = array(
	            'tstamp' => time(),       	// image link last requestet on
	            'page_id' => $page_id		// comma seperated list of pid's where the image has been requested from
	        );
	        $res_realurl = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_flrealurlimage_cache','realurl_path=\''.$path.'\'', $insertArray);
			// linkStatic is switched on, then relink the image static.
			// The obviously lost image will be shown much faster next time
			if ($this->fl_conf['fileLinks']) {
				$this->fl_realimage_url_createFileLink_feHook ($data['image_path'],$data['realurl_path']);
			}
			// cacheControl is switched on and the image has not been modified since last request
			// => loaded from browser cache 
			if ($this->fl_conf['cacheControl'] && $_SERVER['HTTP_IF_MODIFIED_SINCE']) {
				$lastGet = strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']);
				if ($data['tstamp'] != 0 && $lastGet <= $data['tstamp']){
					header("HTTP/1.1 304 Not Modified");
					die();
				}
			}
   			// send headers for image and output the image
   			// this is the "manual" way to display an image
   			else {
   				$info = getimagesize(PATH_site.$data['image_path']);
				header('Content-Type: '.$info['mime']);
				header('Content-Length: '.filesize(PATH_site.$data['image_path']));
				if($GLOBALS['fl_realurl_image']['cacheControl'] && $data['tstamp'] != 0) {
					header('Last-Modified: '.gmdate('D, d M Y H:i:s', $data['tstamp']) . ' GMT');
				}
				readfile(PATH_site.$data['image_path']);
				die();
			}
		}
	}
	
    /**
     * creates a hard-link / sym-link / copy of the oritinal image to the new location
     *
     * @param 		string 		the path to the original image e.g.: typo3temp/pics/2305e38d9c.jpg
     * @param		string      the path to the new image
     * @return 		nothing
     */
	function fl_realimage_url_createFileLink_feHook($org_path,$new_path) {
        // create folder if required
        $new_folder = t3lib_div::dirname($new_path);
		if (!is_dir($new_folder)) {
			mkdir ($new_folder);
		}
		if (TYPO3_OS == 'WIN') {
			if (is_file($new_path)) {
				return;
			}
			// no copy
			if ($this->fl_conf['fileLinks'] == "none") {
				return;
			}
		    // true copy
			elseif ($this->fl_conf['fileLinks'] == "copy") {
				copy($org_path,$new_path);
			}
        	// symlink
        	# ... not possible in WIN => = hard-link
		    // hard-link
			else {
				exec('fsutil hardlink create "'.$new_path.'" "'.$org_path.'"');
			}
		}
        else {
			if (is_file(PATH_site . $new_path)) {
				return;
			}
			// no copy
			if ($this->fl_conf['fileLinks'] == "none") {
				return;
			}
			// true copy
			elseif ($this->fl_conf['fileLinks'] == "copy") {
				copy(PATH_site . $org_path, PATH_site . $new_path);
			}
        	// symlink
			elseif ($this->fl_conf['fileLinks'] == "symLink") {
				symlink('../../'.$org_path, PATH_site . $new_path);
			}
            // hard-link
			else {
				link($org_path, PATH_site . $new_path);
			}
		}
	}
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage_fehook.php']){
   include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage_fehook.php']);
} // if
?>
