<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2008 Tim Lochmueller
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class tx_flrealurlimage_tcmainhooks {    
	/*
	 * Delete the Cache for one Site. $parms['cacheCmd'] is the Page ID.
	 * This Funktion is a Hook function
	 *
	 * @return -
	 */
	 /*
	function clearPageCache($parms, $this_ref){
		$page = (int)$parms['cacheCmd'];
		if(is_int($page) && $page > 0 ){
			$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_flrealurlimage_cache', 'page_id = '.$page);
		}
	}
	*/

	/**
	 * Clear DB cache
	 *
	 * @param	object		$_params: array containing 'cacheCmd'
	 * @return	void
	 */
	function clearDBCache (&$_params) {
		// clear DB tables ... that do not end with 'cache'
		if ($GLOBALS['fl_realurl_image']['clearDBCache']) {
			$tables = explode(',',$GLOBALS['fl_realurl_image']['clearDBCache']);
			foreach ($tables as $table) {
			    # other tables are cleard by the hook
				#if (substr($cacheTable,-5)!='cache') {
					$GLOBALS['TYPO3_DB']->exec_DELETEquery($table,'');
				#}
			}			
		}
	}
	
	/**
	 * Clear file cache
	 *
	 * @param	object		$_params: array containing 'cacheCmd'
	 * @return	void
	 */
	function clearFileCache (&$_params) {
		// clear DB tables ... that do not end with 'cache'
		if ($GLOBALS['fl_realurl_image']['clearDBCache']) {
			$tables = explode(',',$GLOBALS['fl_realurl_image']['clearDBCache']);
			foreach ($tables as $table) {
			    # other tables are cleard by the hook
				if (substr($cacheTable,-5)!='cache') {
					$GLOBALS['TYPO3_DB']->exec_DELETEquery($table,'');
				}
			}			
		}
		// find starting folders for recursive cache clearance
		$cacheFolder = array();
		if (strtolower(trim($GLOBALS['fl_realurl_image']['clearFileCache'])) == "all") {
			$cacheFolder[] = '../typo3temp/';
		}
		elseif (trim($GLOBALS['fl_realurl_image']['clearFileCache']) != "") {
			$cacheFolderTest = explode(',',$GLOBALS['fl_realurl_image']['clearFileCache']);
			foreach ($cacheFolderTest as $folder) {
				if (trim($folder) != "") {
					$cacheFolder[] = '../typo3temp/'.$folder.'/';
				}
			}
		}		
		
		// clear the cache files recursive
		foreach ($cacheFolder as $folder) {
			$this->deleteRecursive($folder);
		}  
	}

	/**
	 * deletes recursive files and folders starting from a given start point
	 *
	 * @param	string		The root folder for deleteRecursive
	 * @return	void
	 */	
	function deleteRecursive($dir) {
		if (is_dir($dir)) {
			$handle = opendir($dir) or debug("<H1>Fatal: No handle ".$dir."</H1>");
			while ($file = readdir($handle)) {
				if ($file == "." || $file == "..") {
					$test = true;   # sorry, lazy programmer not very creative
				}
				elseif (is_dir($dir.$file)) {
					$this->deleteRecursive($dir.$file.'/');
					@rmdir($dir.$file);
				} 
				elseif (is_file($dir.$file)) {
					@unlink($dir.$file);
				}  				
			}
			closedir($handle);
		} 
	}
	
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage_tcmainhooks.php']){
   include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_realurl_image/class.tx_flrealurlimage_tcmainhooks.php']);
} // if
?>